package dk.sosi.sts.server;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.stream.Stream;

import dk.sosi.sts.model.Authorization;
import dk.sosi.sts.model.CprNr;
import dk.sosi.sts.server.test.TestIdentity;
import dk.sosi.sts.server.test.TestIdentityProvider;
import dk.sosi.sts.service.AuthorizationService;

public class AuthorizationServiceStub implements AuthorizationService {
    @Override
    public List<Authorization> getAuthorizations(CprNr cpr) {
        if (cpr.getValue().equals("1802609999")) {
            return Collections.unmodifiableList(Arrays.asList(new Authorization("ZXCVB", "7170"), new Authorization("ABCD", "1234")));
        } else if (cpr.getValue().equals("2501879875")) {
            return Collections.unmodifiableList(Arrays.asList(new Authorization("008NX", "7170")));
        } else if (cpr.getValue().equals("0707070707")) {
            return Collections.unmodifiableList(Arrays.asList(new Authorization("009NX", "7170")));
        } else {
            return TestIdentityProvider.IDENTITIES.stream()
                    .filter(identity -> identity.getCpr().equals(cpr.getValue()))
                    .map(TestIdentity::getAuthorizations)
                    .findAny()
                    .orElse(Collections.emptyList());
        }
    }
}
